Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.management
Class MBeanServerInvocationHandler

    java.lang.Object
      |
      +--javax.management.MBeanServerInvocationHandler

All Implemented Interfaces:
  java.lang.reflect.InvocationHandler

public class MBeanServerInvocationHandler
extends java.lang.Object
implements java.lang.reflect.InvocationHandler

`InvocationHandler` that forwards methods in an MBean's management interface through the MBean server to the MBean.

Given an `MBeanServerConnection`, the `ObjectName` of an MBean within that MBean server, and a Java interface `Intf` that describes the management interface of the MBean using the patterns for a Standard MBean, this class can be used to construct a proxy for the MBean. The proxy implements the interface `Intf` such that all of its methods are forwarded through the MBean server to the MBean.

If you have an MBean server `mbs` containing an MBean with `ObjectName` `name`, and if the MBean's management interface is described by the Java interface `Intf`, you can construct a proxy for the MBean like this:

     Intf proxy = (Intf)
         MBeanServerInvocationHandler.newProxyInstance(mbs,
                                                       name,
                                                       Intf.class,
                                                       false);

Suppose, for example, `Intf` looks like this:

     public interface Intf {
         public String getSomeAttribute();
         public void setSomeAttribute(String value);
         public void someOperation(String param1, int param2);
     }

Then you can execute:

- `proxy.getSomeAttribute()` which will result in a call to `mbs.``getAttribute``(name, "SomeAttribute")`.
- `proxy.setSomeAttribute("whatever")` which will result in a call to `mbs.``setAttribute``(name, new Attribute("SomeAttribute", "whatever"))`.
- `proxy.someOperation("param1", 2)` which will be translated into a call to `mbs.``invoke``(name, "someOperation", <etc>)`.

If the last parameter to `newProxyInstance` is `true`, then the MBean is assumed to be a `NotificationBroadcaster` or `NotificationEmitter` and the returned proxy will implement `NotificationEmitter`. A call to `NotificationBroadcaster.addNotificationListener(javax.management.NotificationListener, javax.management.NotificationFilter, java.lang.Object)` on the proxy will result in a call to `MBeanServerConnection.addNotificationListener(ObjectName, NotificationListener, NotificationFilter, Object)`, and likewise for the other methods of `NotificationBroadcaster` and `NotificationEmitter`.

The methods `Object.toString()`, `Object.hashCode()`, and `Object.equals(Object)`, when invoked on a proxy using this invocation handler, are forwarded to the MBean server as methods on the proxied MBean. This will only work if the MBean declares those methods in its management interface.

Since:
  JMX 1.2
Author:
  Young Yang

Constructor Summary
`MBeanServerInvocationHandler(MBeanServerConnection connection, ObjectName objectName, boolean isNotificationBroadcaster)` Invocation handler that forwards methods through an MBean server.

Method Summary
`java.lang.Object` | `invoke(java.lang.Object proxy, java.lang.reflect.Method method, java.lang.Object[] args)`
`static void` | `main(java.lang.String[] args)`
`static java.lang.Object` | `newProxyInstance(MBeanServerConnection connection, ObjectName objectName, java.lang.Class interfaceClass, boolean isNotificationBroadcaster)` Return a proxy that implements the given interface by forwarding its methods through the given MBean server to the named MBean. This method is equivalent to `Proxy.newProxyInstance``(interfaceClass.getClassLoader(), interfaces, handler)`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MBeanServerInvocationHandler

    public MBeanServerInvocationHandler(MBeanServerConnection connection,
                                        ObjectName objectName,
                                        boolean isNotificationBroadcaster)

  Invocation handler that forwards methods through an MBean server. This constructor may be called instead of relying on `newProxyInstance(javax.management.MBeanServerConnection, javax.management.ObjectName, java.lang.Class, boolean)`, for instance if you need to supply a different `ClassLoader` to `Proxy.newProxyInstance`.

  Parameters:
    `connection` - the MBean server connection through which all methods of a proxy using this handler will be forwarded.
    `objectName` - the name of the MBean within the MBean server to which methods will be forwarded.

Method Detail

### newProxyInstance

    public static java.lang.Object newProxyInstance(MBeanServerConnection connection,
                                                    ObjectName objectName,
                                                    java.lang.Class interfaceClass,
                                                    boolean isNotificationBroadcaster)

  Return a proxy that implements the given interface by forwarding its methods through the given MBean server to the named MBean.

  This method is equivalent to `Proxy.newProxyInstance``(interfaceClass.getClassLoader(), interfaces, handler)`. Here `handler` is the result of `new MBeanServerInvocationHandler(connection, objectName)`, and `interfaces` is an array that has one element if `isNotificationBroadcaster` is false and two if it is true. The first element of `interfaces` is `interfaceClass` and the second, if present, is `NotificationEmitter.class`.

  Parameters:
    `connection` - the MBean server to forward to.
    `objectName` - the name of the MBean within `connection` to forward to.
    `interfaceClass` - the management interface that the MBean exports, which will also be implemented by the returned proxy.
    `isNotificationBroadcaster` - make the returned proxy implement `NotificationEmitter` by forwarding its methods via `connection`.
  Returns:
    the new proxy instance.

### invoke

    public java.lang.Object invoke(java.lang.Object proxy,
                                   java.lang.reflect.Method method,
                                   java.lang.Object[] args)
                            throws java.lang.Throwable

  Specified by:
    `invoke` in interface `java.lang.reflect.InvocationHandler`

### main

    public static void main(java.lang.String[] args)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD